<template>
  <div>
    <div class="title-section">
      <div class="title">
        All Projects
      </div>
      <section class="filters">
        <p class="sort"> SORT BY ROLE </p>
        <button class="btn" type="button" @click="getProjectBy('visitor')"
                :class="{active: activeBtn === 'visitor' && active }">
          Visitor
        </button>
        <button class="btn" type="button" @click="getProjectBy('developer')"
                :class="{active: activeBtn === 'developer' && active}">Developer
        </button>
        <button class="btn" type="button" @click="getProjectBy('admin')"
                :class="{active: activeBtn === 'admin' && active}">Admin
        </button>
      </section>
    </div>
    <div>
      <div class="divider"></div>
      <div class="project-list" v-if="user.projects.length > 0">
        <Card v-for="project in user.projects" :key="project.id"
              :role='project.role'
              :project='project.project'
        />
        <AddProjectLimit v-if="user.account_type === 'free' && user.projects.length == 5"/>
        <AddProject v-else/>
      </div>
      <div class="project-list" v-else>
        <AddProject/>
    </div>
    </div>
  </div>
</template>

<script>
import Card from '../components/Projects/Card'
import Vuex from "vuex";
import AddProject from "../components/Projects/AddProject";
import AddProjectLimit from "../components/Projects/AddProjectLimit";

export default {
  name: 'DashboardUser',
  components: {
    Card,
    AddProject,
    AddProjectLimit
  },
  data() {
    return {
      active: false,
      activeBtn: '',
      maxLengthProjects: 0,
    }
  },
  methods: {
    ...Vuex.mapActions(['getUserProjects','getProjectsByFilter']),
    getProjectBy(filtre) {
      this.active = !this.active
      if (!this.active) {
        this.getUserProjects(this.user.id)
      } else {
        this.activeBtn = filtre
        this.user.projects = this.filtered(filtre)
      }
    }
  },
  computed: {
    ...Vuex.mapGetters(['user', 'filtered','userProjects']),
  },
  created() {
    document.title = "WebSandBox | Projects";
    this.getUserProjects(this.user.id)
    if(this.user.account_type == 'free') {
        this.maxLengthProjects = 5
    } else this.maxLengthProjects = 10
  }
}
</script>

<style scoped>
.divider {
  border-top: solid 1px var(--color-primary-blue);
  height: 1px;
}

.project-list {
  padding: 20px;
  flex-wrap: wrap;
  display: flex;
  flex-direction: row;
  align-items: stretch;
}

.btn {
  padding: 10px 20px;
  color: grey;
  background-color: #e6e6e6;
  border-radius: 40px;
  font-size: 16px;
  cursor: pointer;
  outline: none;
  border: none;
  text-decoration: none;
  margin: auto;
}

.active {
  color: white;
  background-color: var(--color-primary-blue);
}

.project-list > .project {
  padding: 20px;
  display: flex;
}

.filters {
  display: inline-flex;
}

.title-section {
  justify-content: space-between;
  padding: 4em 2em ;
  flex-wrap: wrap;
  display: flex;
}
.sort {
  padding: 10px 20px;
  color: grey;
  font-size: 16px;
  text-decoration: none;
  margin: auto;
}

</style>